# frozen_string_literal: true
require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe CasesController, type: :controller do
  # This should return the minimal set of attributes required to create a valid
  # Case. As you add validations to Case, be sure to
  # adjust the attributes here as well.
  let(:case) { create(:case) }

  let(:invalid_attributes) { attributes_for(:case, keyword: nil) }

  let(:cse) { create(:case) }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # CasesController. Be sure to keep this updated too.
  let(:valid_session) do
    { user_id: { 'uid' => create(:user).uid, 'extra' => {},
                 'credentials' => { 'expires_at' => 1.hour.from_now.to_i } } }
  end

  before { cookies[:sso_session] = 'sso_session_random_key' }

  describe 'GET #index' do
    it 'assigns all cases as @cases' do
      get :index, params: {}, session: valid_session
      expect(assigns(:cases)).to eq([cse])
    end
  end

  describe 'GET #show' do
    it 'assigns the requested case as @case' do
      get :show, params: { id: cse.to_param }, session: valid_session
      expect(assigns(:case)).to eq(cse)
    end
  end

  describe 'GET #new' do
    it 'assigns a new case as @case' do
      get :new, params: {}, session: valid_session
      expect(assigns(:case)).to be_a_new(Case)
    end
  end

  describe 'GET #edit' do
    it 'assigns the requested case as @case' do
      get :edit, params: { id: cse.to_param }, session: valid_session
      expect(assigns(:case)).to eq(cse)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      it 'creates a new Case' do
        expect do
          post :create, params: { case: attributes_for(:case) }, session: valid_session
        end.to change(Case, :count).by(1)
      end

      it 'assigns a newly created case as @case' do
        post :create, params: { case: attributes_for(:case) }, session: valid_session
        expect(assigns(:case)).to be_a(Case)
        expect(assigns(:case)).to be_persisted
      end

      it 'redirects to the created case' do
        post :create, params: { case: attributes_for(:case) }, session: valid_session
        expect(response).to redirect_to(Case.last)
      end
    end

    context 'with invalid params' do
      it 'assigns a newly created but unsaved case as @case' do
        post :create, params: { case: invalid_attributes }, session: valid_session
        expect(assigns(:case)).to be_a_new(Case)
      end

      it "re-renders the 'new' template" do
        post :create, params: { case: invalid_attributes }, session: valid_session
        expect(response).to render_template('new')
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) { attributes_for(:case) }

      it 'updates the requested case' do
        put :update, params: { id: cse.to_param, case: new_attributes }, session: valid_session
        cse.reload
        expect(cse.keyword).not_to eq(new_attributes[:keyword])
      end

      it 'assigns the requested case as @case' do
        put :update, params: { id: cse.to_param, case: attributes_for(:case) },
                     session: valid_session
        expect(assigns(:case)).to eq(cse)
      end

      it 'redirects to the case' do
        put :update, params: { id: cse.to_param, case: { title: 'new_title' } },
                     session: valid_session
        expect(response).to redirect_to(cse)
      end
    end

    context 'with invalid params' do
      it 'assigns the case as @case' do
        put :update, params: { id: cse.to_param, case: invalid_attributes }, session: valid_session
        expect(assigns(:case)).to eq(cse)
      end

      it "re-renders the 'edit' template" do
        put :update, params: { id: cse.to_param, case: invalid_attributes }, session: valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    before(:each) { create(:case) }

    it 'destroys the requested case' do
      expect do
        delete :destroy, params: { id: Case.last.to_param }, session: valid_session
      end.to change(Case, :count).by(-1)
    end

    it 'redirects to the cases list' do
      delete :destroy, params: { id: Case.last.to_param }, session: valid_session
      expect(response).to redirect_to(cases_url)
    end
  end
end
